pipeline {
  agent any
  tools {
    maven 'M2_HOME'
  }
  stages {
         stage ('Initialize') {
         steps {
              sh '''
                M2_HOME=/opt/maven
                M2=/opt/maven/bin
                PATH=$PATH:$HOME/bin/:$JAVA_HOME:$M2:$M2_HOME
                export PATH
                echo "PATH = ${PATH}"
                echo "M2_HOME = ${M2_HOME}"
                whoami
                 '''
             }
         }
          stage('Build app') {
          steps {
              sh 'mvn clean install package'
          }
          post{
          failure{
            emailext to: "jagadeesh.j@apollohl.com",
            subject: "jenkins build:${currentBuild.currentResult}: ${env.JOB_NAME}",
            body: "${currentBuild.currentResult}: Job ${env.JOB_NAME}\nMore Info can be found here: ${env.BUILD_URL}"
          } 
          //changed{
          //  emailext to: "jagadeesh.j@apollohl.com",
          //  subject: "jenkins build:${currentBuild.currentResult}: ${env.JOB_NAME}",
          //  body: "${currentBuild.currentResult}: Job ${env.JOB_NAME}\nMore Info can be found here: ${env.BUILD_URL}"
        //}    
          success{
            emailext to: "jagadeesh.j@apollohl.com",
            subject: "jenkins build:${currentBuild.currentResult}: ${env.JOB_NAME}",
            body: "${currentBuild.currentResult}: Job ${env.JOB_NAME}\nMore Info can be found here: ${env.BUILD_URL}"
        }
      }
    }
      stage("build & SonarQube analysis") {
        steps {
          withSonarQubeEnv('sonar') {
            sh 'mvn clean package sonar:sonar'
          //sh '/root/sonar-scanner-4.7.0.2747-linux/conf/sonar-scanner.properties 
          }
        }
      }
      stage ('Test') { 
      steps{
            echo "test successful";
            } 
         }
      stage ('Deploy to Tomcat') {
      steps {
                // SSH into the remote server and deploy the WAR file to Tomcat
      sshagent(['4ec2bb2f-879a-4dab-b5fb-0404a7f7baa4'])
             {
                sh "scp /var/lib/jenkins/workspace/java-app/webapp/target/webapp.war dev_user@3.109.231.32:/opt/tomcat/qa_webapps/sonar/"
        }  
      }
    }
  }
}